       SUBROUTINE  SO_BSEC( bulltn, ipos, kpos, ksect, iret )
C************************************************************************
C*                                                                      *
C* SO_BSEC                                                              *
C*                                                                      *
C* This subroutine checks that this is a SATOB bulletin which contains  *
C* either section 2 or section 3 data.                                  *
C*                                                                      *
C* SO_BSEC( BULLTN, IPOS, KPOS, KSECT, IRET )                           *
C*                                                                      *
C* Input parameters:                                                    *
C*      BULLTN          CHAR*             Bulletin array                *
C*					                                *
C* Output parameters:                                                   *
C*      ksect           INTEGER           Section indicator             *
C*                                         0 = no section 2 or 3        *
C*                                         2 = section 2 in bulletin    *
C*                                         3 = section 3 in bulletin    *
C*      IPOS            INTEGER           Points to first Y in YYXX     *
C*      KPOS            INTEGER           Points to start of BBBnn group*
C*	IRET	        INTEGER           Return code                   *
C*                                         0 = normal return            *
C*                                         1 = reject bulletin          *
C*                                                                      *
C**                                                                     *
C* Log:                                                                 *
C* R. Hollern/NCEP      10/96                                           *
C* R. Hollern/NCEP       3/98   Changed interface and cleaned up code   *
C************************************************************************
        INCLUDE 'socmn.cmn'
C*
        CHARACTER*(*)   bulltn
C------------------------------------------------------------------------
        ksect = 0
        iret = 0
C
C*      Check if SATOB bulletin.
C
        ipos = index( bulltn ( 1:50 ), 'YYXX' )
C
        IF ( ipos .eq. 0 ) THEN
            iret = 1
            RETURN
        END IF
C
C*      Check if bulletin contains section 2 or section 3 data.
C
        kpos = ipos + 15
        mpos = index( bulltn ( kpos:kpos+20 ), ' 222 ' )
C
        IF ( mpos .gt. 0 ) THEN
            ksect = 2
            kpos = kpos + mpos + 4
          ELSE
            npos = index( bulltn ( kpos:kpos+20 ), ' 333 ' )
            IF ( npos .gt. 0 ) THEN
                ksect = 3
                kpos = kpos + npos + 4
              ELSE
C
C*              Don't decode data in bulletin.
C
                iret = 1
                RETURN
            END IF
        END IF
C*
	RETURN
	END
