       SUBROUTINE  SO_DDFF ( bulltn, kpos, iret )
C************************************************************************
C*                                                                      *
C* SO_DDFF                                                              *
C*                                                                      *
C* This routine decodes the section 2 or section 3 ddfff group.  The    *
C* group contains the wind direction and speed at the given latitude    *
C* and longitude location.                                              *
C*                                                                      *
C* SO_DDFF ( BULLTN, KPOS, IRET )                                       *
C*                                                                      *
C* Input parameters:                                                    *
C*      BULLTN          CHAR*           Bulletin array                  *
C*                                                                      *
C*      IOBSPT          INTEGER         Index value for pointer arrays  *
C*                                                                      *
C* Input and output parameters:                                         *
C*      KPOS            INTEGER         On input, points to start of    *
C*                                      ddfff group; on ouput, points   *
C*                                      to start of the next group      *
C*                                      after ddfff group               *
C*					                                *
C* Output parameters:                                                   *
C*      RIVALS(IRWDIR)  REAL            Wind direction at data point    *
C*      RIVALS(IRWDSP)  REAL            Wind speed in m/sec at data pnt *
C*	IRET	        INTEGER         Return code                     *
C*				   	 0 = normal return              *
C*                                       1 =  problems                  *
C*                                                                      *
C**                                                                     *
C* Log :                                                                *
C* R. Hollern/NCEP      10/96                                           *
C* R. Hollern/NCEP      11/96  Added call to PR_KNMS                    *
C* R. Hollern/NCEP       3/98  Changed interface and cleaned up code    *
C* J. Ator/NCEP		01/02  Remove iuwind from /COMMON/		*
C************************************************************************
        INCLUDE 'socmn.cmn'
C*
        CHARACTER*(*)   bulltn
C*
        CHARACTER*2   fld2*2,   fld1*1
C------------------------------------------------------------------------
        iret = 0
        ipt = kpos
        kpos = kpos + 6
C
C*      Get wind direction in tens of degrees.
C
        fld2 = bulltn ( ipt:ipt+1 )
        CALL  ST_INTG ( fld2, ival, ier )
        IF ( ier .eq. 0 ) THEN
            IF ( ival .ge. 0 .and. ival .le. 36 ) THEN
                IF ( ival .eq. 36 ) ival = 0
                xval = ival     
                ywdir = 10. * xval 
              ELSE
                iret = 1
                RETURN
            END IF
          ELSE
            iret = 1
            RETURN
        END IF
C
C*      Round wind direction to nearest 5 degrees and add units
C*      digit to the hundreds digit of the wind speed.
C
        ipt = ipt + 2
        fld1 = bulltn (ipt:ipt)
        CALL  ST_INTG ( fld1, ival, ier )
        IF ( ier .eq. 0 ) THEN
            ihfff = 100 * ival
            IF ( ival .eq. 5 ) THEN
                ywdir = ywdir + 5.0
                ihfff = 0
              ELSE IF ( ival .eq. 6 .or. ival .eq. 7 ) THEN
                ywdir = ywdir + 5.0
                ihfff = 100 * ( ival - 5 )
            END IF
          ELSE
            iret = 1
            RETURN
        END IF
C
        rivals ( irwdir ( iobspt ) ) = ywdir
C
C*      Get wind speed.
C
        ipt = ipt + 1
        fld2 = bulltn ( ipt:ipt+1 )
        CALL  ST_INTG ( fld2, ival, ier )
        IF ( ier .eq. 0 ) THEN
            ywspd = ihfff + ival
          ELSE
            iret = 1
            RETURN
        END IF
C
        IF ( INT ( rivals ( irtiwm ) ) .eq. 4 ) THEN
C
C*          Convert wind speed from knots to m/sec.
C
            x  = ywspd
            ywspd = PR_KNMS ( x )
        END IF
C
        rivals ( irwdsp ( iobspt ) ) = ywspd
C*
	RETURN
	END
