#include "geminc.h"
#include "gemprm.h"
#include "socmn.h"

/*
**  Function prototypes.
*/
void so_icpt( char [][8], char[][8], int * );

char *outstr( char [] );


void so_icpt( char rimnem[][8], char cimnem[][8], int *iret )
{

    int ierwlg;

    unsigned int jj, npts; 

    char logmsg[201];

/*
**  Print out all of the single-level character interface values
**  that are not "missing".
*/

    for ( jj = 0; jj < NCIMN; jj++ ) {
        if ( cintfv.civals[jj][0] != CHSPAC ) {
            sprintf( logmsg, "%s = ", outstr(cimnem[jj]) );
            sprintf( &(logmsg[strlen(logmsg)]), "%s\n" ,
		     outstr(cintfv.civals[jj]) );
        dc_wclg( 3, "DC", 2, logmsg, &ierwlg );
	}
    }

/*
**  Print out all of the single-level real interface values
**  that are not "missing".
*/
    for ( jj = 0; jj < NRSIMN; jj++ ) {
	if ( ! ERMISS( rintfv.rivals[jj] ) ) {
	    sprintf( logmsg, "%s = %10.2f\n",
		     outstr(rimnem[jj]), rintfv.rivals[jj] );
	    dc_wclg( 3, "DC", 2, logmsg, &ierwlg );
	}
    }

/*
**  Print out all of the multi-level interface values.
*/

/*
**  Observational data points.
*/
       npts = ( unsigned int ) rintfv.rivals[(rintfp.irnpts)-1];

       sprintf( logmsg, "%s = %u\n",
	     outstr(rimnem[(rintfp.irnpts)-1]), npts );
       dc_wclg( 3, "DC", 2, logmsg, &ierwlg );

       if ( npts > 0 ) {
         strcpy(   logmsg,      outstr(rimnem[(rintfp.irslat[0])-1]) );
	 strcpy( &(logmsg[8]),  outstr(rimnem[(rintfp.irslon[0])-1]) );
	 strcpy( &(logmsg[16]),  outstr(rimnem[(rintfp.irpres[0])-1]) );
	 strcpy( &(logmsg[24]), outstr(rimnem[(rintfp.irtmdb[0])-1]) );
	 strcpy( &(logmsg[32]), outstr(rimnem[(rintfp.irwdir[0])-1]) );
	 strcpy( &(logmsg[40]), outstr(rimnem[(rintfp.irwdsp[0])-1]) );
	 dc_wclg( 3, "DC", 2, logmsg, &ierwlg );

	 for ( jj = 0; jj < npts; jj++ ) {
	    sprintf( logmsg,
		     "%8.2f %8.2f %8.2f %8.2f %8.2f %8.2f\n",
		     rintfv.rivals[(rintfp.irslat[jj])-1],
		     rintfv.rivals[(rintfp.irslon[jj])-1],
		     rintfv.rivals[(rintfp.irpres[jj])-1],
		     rintfv.rivals[(rintfp.irtmdb[jj])-1],
		     rintfv.rivals[(rintfp.irwdir[jj])-1],
		     rintfv.rivals[(rintfp.irwdsp[jj])-1] );
	    dc_wclg( 3, "DC", 2, logmsg, &ierwlg );
         }
      }

/*
**  Set return code.
*/
    *iret = 0;

    return;
}

char *outstr( char string[] ) {

    unsigned short ii;

    static char tmpstr[9];

/*
**  Return a null-terminated copy of string.
*/
    for ( ii = 0; ii < 8; ii++ ) {
	tmpstr[ii] = string[ii];
    }
    tmpstr[8] = '\0';

    return tmpstr;
}
